/* 
 * CSE142, 99 Winter
 * Homework 5
 * Valentine's Day
 *
 * Author:     Bryan Love
 * Student ID: 9835212
 * Section:    AC
 *	
 * STARTER PROGRAM
 *
 * To start with, your job is to figure out how this program works.
 *
 * Greeting Card Designer (Ultimate version)
 *
 *  The GP142 graphics window shows some buttons and the inside
 *  or outside (cover) of a greeting card.  The idea is that you 
 *  can design what you want to card to look like by adding and moving
 *  objects: 
 *    messages, message color and position
 *    shapes,   shape color and position
 *
 *   To place a message or a greeting, you click on an appropriate button, and 
 *   then you can click on the desired position in the card.  
 
 *	 In this starter version, you can do much less.
 *   You can change the card background, place one shape on the card,
 *   and change the shape back and forth between two possible kinds.
 */

#include "gp142.h"
#include <math.h>
#include <time.h>
	/* <time.h> is here only so that one function can be called
	to seed the random number generator.
	Put it here in your program and forget about it, 
	just in case you decide later you need to use random numbers.
	*/

#define TRUE    		1
#define FALSE   		0

/*
 * The state, or status you are in determines what happens when you click 
 * the card:
 * ADD SHAPE   -- you click the card, and a new object is placed there.
 *                You get into this mode by clicking an ADD button.
 *                After doing an ADD, you are put into SELECTED mode.
 * SELECTED    -- An object is selected. In this mode, the type 
 *                rotation applies to thecurrent object.
 */
/* Hint: you may need to add statuses when you make the program more complex.*/
#define STATUS_ADD_SHAPE 1
#define STATUS_SELECTED 2
#define STATUS_DRIVING  3
#define STATUS_WEATHER  4

/* Configure the appearance of the buttons on the menu bar 
 * by setting the number of pixels of button height and width
 */
#define BUTTON_HEIGHT  	35
#define BUTTON_WIDTH 	100

/*change this if you add or delete buttons*/
#define NUM_BUTTONS 	6
#define SELECTED_COLOR  RED

/* Position of the card in the window */
#define PAGE_LLX (-GP142_XMAX + BUTTON_WIDTH +60)
#define PAGE_LLY (-GP142_YMAX + 100)
#define PAGE_WIDTH (GP142_XMAX - PAGE_LLX - 80)
#define PAGE_HEIGHT (GP142_YMAX - PAGE_LLY - 50)

/* For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.
 */
#define FILL 0
#define NOFILL 1


/* Types of objects we support.  (Perhaps not all types are used yet.)*/
#define OBJECT_NONE 0
#define OBJECT_SHAPE 1
#define OBJECT_MESSAGE 2

/* max number of objects aloud on card */
#define MAX_OBJECTS	10
#define MAX_ARRAY_SIZE		25

/*if you add new types, you may need to change this*/
#define MAX_SHAPES 3
#define MAXI_MESSAGES 5
#define FIRST_SHAPE_NUM 0

/* These are the kinds of shapes we support.  You'll need to add more. */
#define SHAPE_HEART 0
#define SHAPE_STAR  1
#define SHAPE_ROAD  2

#define TEXT_1		5
#define TEXT_2		6
#define TEXT_3		7
#define TEXT_4		8
#define TEXT_5		9
/* Hint: once you understand how these shape types are used, you may decide
 * to do something similar with messages
 */

/*Possible places for mouse clicks*/
#define CLICK_BUTTON 1  /* You clicked on SOME button (doesn't say which one)*/
#define CLICK_CARD 2    /* You clicked in the card area */
#define CLICK_OUTSIDE 3	/* You clicked outside the card area, not on a button*/	

/*Possible types of weather*/
#define CALM	0
#define SUNNY	1
#define RAINY	2
#define SNOWY	3
#define WEIRD	4

struct SHAPES
{
	int color;
	int object_ID;
	int obj_x;
	int obj_y;
};
struct MESSAGES
{
	int color;
	int object_ID;
	int obj_x;
	int obj_y;
};

/*******************  FUNCTION PROTOTYPES **************************/

/* Drawing functions */
void DrawBlankScreen (void);
void DrawButtons(int last_button);
void DrawCard (int background_color, int status, int message_count, 
			   int shape_count, int object_type, int object_num, 
			   int object_color, int object_x, int object_y, 
			   int, struct MESSAGES [], struct SHAPES []);
void DrawShape(int color, int, int*, struct MESSAGES [], 
			   struct SHAPES shapes[], int message_count, int shape_count);
void Draw_Text( int color, int back_color, int *status,
			   struct MESSAGES messages[], int message_count );
void DrawHeart (int x, int y, int color, int h);
void DrawStar (int x, int y, int color);
void Road( int color, int );
void Draw_Road( int color, int x, int y, int );
void Draw_Car( int color, int back_color );
void Draw_Steering( int color, int );
void Draw_Dash( int );
void Draw_Hood( int );
void Draw_Weather( int, int, int, int);
void Draw_Sunny_Day();
void Draw_Tree( int, int, int );
void Draw_Rainy_Day( int );

/* Mouse click handling functions */
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
					  int *status, int *message_count, int *shape_count,
					  int *object_type, int *object_num, int *object_color, 
					  int *object_x, int *object_y, int *weather_type,
					  struct MESSAGES messages[],
					  struct SHAPES shapes[], int *, int *);
int ClassifyMouseClick(int mouse_x, int mouse_y);
void HandleButton(int x, int y, int *background_color, int *status,
				  int *message_count, int *shape_count, 
				  int *object_type, int *object_num,
				  int *weather_type, struct MESSAGES messages[],
				  struct SHAPES shapes[], int *, int *,
				  int *, int *);

/* Add a shape to the card. */
void AddShape(int x, int y, int *status, int *message_count, int *shape_count,
			  int *object_type, int *object_num, int *object_color, 
			   int *object_x, int *object_y);
/*void AddText(struct MESSAGES[], int );*/
void Initialize_Messages_Array( struct MESSAGES Array[] );
void Initialize_Shapes_Array( struct SHAPES Array[] );

/*****************************************************************************

     MAIN

*****************************************************************************/

/* main() has two chief purposes: to contain the important variables and 
 *initialize them, and to contain the "event loop," which constantly looks 
 *to see if an event has happened, and then processes the event by calling 
 *an appropriate function. An example of an event is a mouse click.
 */
int main(void)
{
	
	int i = 0;
	int quit = FALSE;              /* becomes TRUE to exit program */
	int mouse_x, mouse_y;          /* coordinates of a mouse click */
	char key_hit;				   /* which key was hit            */
	struct MESSAGES messages[10];
	struct SHAPES shapes[10];
	static int shape_color = 0;
	static int text_color = 0;
	
	/*variables and their default values*/
	int background_color = BLACK;
	int status = STATUS_ADD_SHAPE;
	int weather_type = CALM;

	
	/* Each object will have a number telling what kind of object it is, a color,
	 * and an x and y coordinate.  You'll need to make these into arrays so you
	 * can support more than one object.
	 */
	int message_count = 0;          /* How many messages on the page?*/
	int shape_count   = 0;			/* How many shapes on the page?  */
	int object_type = OBJECT_NONE;  /* Can also be a shape           */
	int object_num;                 /* If type is shape, either 
									   heart or star                 */
	int object_color;               /* Color of object               */
	int object_x;                   /* Position of object            */
	int object_y;
	
	int last_button = -1;           /* Keep track of the last button clicked.
	                                   This would be usefull when highlighting
	                                   the last button the user clicked */

	int event; /*the most recent GP142 event*/
	
	time_t t; /*needed only when initializing a random number generator*/
	

	/*
	 * INITIALIZATIONS
	 */
	srand (time(&t));	    /* Seed the random number generator. This is 
							   something you should do if you plan to use 
							   random numbers. Leave it here in your program 
							   and forget about it.*/
	Initialize_Messages_Array( messages );
	Initialize_Shapes_Array( shapes );

	/* These GP142 initializations don't need to be changed */
	GP142_open();           /* Open and init the GP142 Graphics Window      */
	GP142_show_text(0);     /* Hide the text window                         */
	GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */
	
	GP142_clear();	        /* This will clear the window & paint it white. */
	GP142_animate(ANI_RUN); /* Enable periodic events                       */
	
	
	
	/*
	 * The main event loop:
	 * --- ---- ----- -----
	 * wait for the next user action, such as a mouse click or keyboard
	 * keypress, or a periodic update event (allowing us to display the
	 * next frame of an animation -- not used directly in this program)
	 * and call the appropriate function to handle it.  Repeat this until 
	 * the user signals "quit".
	 */
	
     while (!quit) {  /*this is the famous "event loop" */
		
		/*start by redrawing everything */
		DrawBlankScreen ();
		DrawCard (background_color, status, message_count, shape_count, 
			      object_type, object_num, object_color, object_x, 
				  object_y, weather_type, messages, shapes );
		Draw_Weather( weather_type, mouse_x, mouse_y, background_color );
		DrawButtons(last_button);	  /* Show the buttons...*/ 
		
		/*Wait for something to happen */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);
		
		/* Something just happened.  Figure out what it was, and react 
		   appropriately. */
		switch (event) {
		case GP142_QUIT:
			quit = TRUE;           /* set flag to terminate loop           */
			break;
			
		case GP142_KBD:  /*A key was pressed */
			/*not needed for this program. Use this if user will need to 
			  hit a key. Note that scanf CANNOT be used with GP142.  If you 
			  use this, the key character value is in variable "key_hit"*/
			
			break;
			
		case GP142_MOUSE:
			/* A mouse click has occurred. Call the mouse handler to 
			   decide where the click was and react as needed. */
			HandleMouseClick(mouse_x, mouse_y, &background_color, &status, 
					         &message_count, &shape_count, &object_type, 
							 &object_num, &object_color, 
							 &object_x, &object_y, &weather_type, messages,
							 shapes, &shape_color, &text_color);
			break;
			
		case GP142_PERIODIC:
			/*An events has occurred simply because some time has passed,*/
			/*not currently used in the program*/		
			break;

		default:
			
			break;
			
		}  /*end switch */
		
	}  /* end event loop */
	
	
	/*
	 * WRAP-UP
	 */
	GP142_close();         /* clean up and close graphics window   */
	
	return 0;
}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/
void Initialize_Messages_Array( struct MESSAGES Array[] )
{
	int i;
	
	for( i = 0; i < MAX_OBJECTS; i++ )
	{
		Array[ i ].color = RED;
		Array[ i ].object_ID = 0;
		Array[ i ].obj_x = 0;
		Array[ i ].obj_y = 0;
	}	
}

/**************************************************************************/
void Initialize_Shapes_Array( struct SHAPES Array[] )
{
	int i;
	
	for( i = 0; i < MAX_OBJECTS; i++ )
	{
		Array[ i ].color = RED;
		Array[ i ].object_ID = 0;
		Array[ i ].obj_x = 0;
	    Array[ i ].obj_y = 0;
	}
}

/* 
 * For a blank screen just draw a white rectangle that covers the whole
 * GP142 window.
 */
void DrawBlankScreen (void) {
	int font_size = 14;

	GP142_rectangleXY (WHITE,
					-GP142_XMAX, -GP142_YMAX,
					GP142_XMAX, GP142_YMAX,
					FILL);

} /*end DrawBlankScreen */


/* 
 * Draws the buttons 
 */
void DrawButtons(int last_button)
{
/* To add buttons, you'll need to change the #defined constant NUM_BUTTONS
 * and add messages to this array.  Although we haven't covered 2-D arrays
 * yet, you should be able to play with this enough to get it going.
 * Look at course packet, page N-25, for a similar example.
 */
	char b_labels [NUM_BUTTONS][25] = 
	{
		"Background color",
			"Add/Change shape",
				"Change Weather",
					" Add/Change\n Message",
						" Change Shape\n Color",
							" Change Message\n Color"
	};
	
	int i, text_offset = -GP142_XMAX + 6, font_size = 12;
	int y, label_y;
	
	/* draw rectangles and labels for each button */
	for(i = 0; i < NUM_BUTTONS; i++) {
		y = GP142_YMAX - i * BUTTON_HEIGHT;
		
		GP142_rectangleXY(BLACK,
			-GP142_XMAX + 4,
			y - 2,
			-GP142_XMAX + BUTTON_WIDTH,
			y - BUTTON_HEIGHT - 2, 1);
		
		
		label_y = y - BUTTON_HEIGHT/2;
		/* highlight last pushed button */
		if (i == last_button)
			GP142_printfXY(SELECTED_COLOR, text_offset, label_y, font_size, b_labels[i]);	
		else
			GP142_printfXY(BLACK, text_offset, label_y, font_size, b_labels[i]);	
	}	
}


/*
 * Render (draw) the page and all its contents.
 */
#define MESSAGE_HIGH_Y	PAGE_LLY + PAGE_HEIGHT + 10
#define MESSAGE_LOW_Y	PAGE_LLY - 40

void DrawCard (int background_color, int status, int message_count, 
			   int shape_count, int object_type, int object_num, 
			   int object_color, int object_x, int object_y, 
			   int weather, struct MESSAGES messages[],
			   struct SHAPES shapes[])
{
	int font_size = 14;
	static int total_messages = 0;
	
	/*
	 * Draw the background of the card.
	 */
	GP142_rectangleXY (background_color,
		PAGE_LLX, PAGE_LLY,
		PAGE_LLX+ PAGE_WIDTH, PAGE_LLY+ PAGE_HEIGHT,
		FILL);
	
	/* 
	 * Draw a shape on the card, if one currently exists.
	 */
	if ((shape_count <= 10) && (object_type == OBJECT_SHAPE)) 
		DrawShape( object_color, background_color, &status, messages,
				   shapes, message_count, shape_count);
	else if( (message_count <= 10) && (object_type == OBJECT_MESSAGE))		
		Draw_Text( object_color, background_color, &status, messages,
				   message_count );
	
	
	/*
	 * Write an appropriate status message below the buttons
	 */

	if( (object_type) == OBJECT_SHAPE )
		GP142_printfXY (BLACK, PAGE_LLX-(150), MESSAGE_LOW_Y, font_size-3,
			"ADD STATUS: SHAPES");
	else
		GP142_printfXY (BLACK, PAGE_LLX-(150), MESSAGE_LOW_Y, font_size-3,
			"ADD STATUS: TEXT");
	
	
	/* this switch controls messages at bottom of window */
	switch (status) {
	case STATUS_ADD_SHAPE:
		GP142_printfXY (BLACK, PAGE_LLX, MESSAGE_LOW_Y, font_size,
			"Click on the card to add a shape or message");
		break;
	case STATUS_SELECTED:
		GP142_printfXY (RED, PAGE_LLX, MESSAGE_LOW_Y, font_size-3,
			"Object selected. Click buttons to change shape or message.");
		break;
	case STATUS_DRIVING:
		GP142_printfXY (RED, PAGE_LLX, MESSAGE_LOW_Y, font_size+5,
			"             YOU DRIVE ME WILD!");
		break;
	case STATUS_WEATHER:
		GP142_printfXY (BLACK, PAGE_LLX, MESSAGE_LOW_Y, font_size,
			"Click on the card to add a shape or message");
		break;
	default:
		GP142_printfXY (BLACK, PAGE_LLX, MESSAGE_LOW_Y, font_size,
			"Status error -- notify programmer");
		break;
	} /*end switch */
	
	/* this switch controls messages at top of window */
	switch (weather) {
	case CALM:
		GP142_printfXY (BLACK, PAGE_LLX, MESSAGE_HIGH_Y, font_size+3,
			"HAPPY VALENTINE'S DAY ");
		break;
	case SUNNY:
		GP142_printfXY (BLACK, PAGE_LLX, MESSAGE_HIGH_Y, font_size+3,
			"WHEN IT'S SUNNY YOU'RE MY HONEY!");
		break;
	case RAINY:
		GP142_printfXY (RED, PAGE_LLX, MESSAGE_HIGH_Y, font_size+3,
			"WHEN IT'S MOIST YOU'RE MY CHOICE!");
		break;
	case SNOWY:
		GP142_printfXY (RED, PAGE_LLX, MESSAGE_HIGH_Y, font_size+3,
			"WHEN IT'S SNOWS MY LOVE FOR YOU GROWS!");
		break;
	case WEIRD:
		GP142_printfXY (BLACK, PAGE_LLX, MESSAGE_HIGH_Y, font_size+3,
			"WHEN THINGS GET WEIRD I WANT YOU NEAR!");
		break;
	} /*end switch */
} /*end DrawPage */


/*
 * Draw one shape.
 */
#define HEART_WIDTH 35
void DrawShape(int color, 
			   int back_color,
			   int *status,
			   struct MESSAGES messages[],
			   struct SHAPES shapes[],
			   int message_count,
			   int shape_count)
{
	int i;

		for( i = 0; i <= shape_count; i++ )
		{
			switch (shapes[i].object_ID ) 
			{
				case SHAPE_HEART:
				{	
					int h = (HEART_WIDTH/2) + (rand () %4);
					DrawHeart (shapes[i].obj_x, shapes[i].obj_y, shapes[i].color, h);
				}
					break;
				case SHAPE_STAR:
					DrawStar (shapes[i].obj_x, shapes[i].obj_y, shapes[i].color);
					break;
				case SHAPE_ROAD:
					{
						*status = STATUS_DRIVING;
						Road( YELLOW, back_color );
					}
					break;
				default:
					/* Unknown shape selected */
					break;

			} /*end switch*/
		}

	
	Draw_Text( color, back_color, status, messages, message_count );
}

/*****************************************************************/
void Draw_Text( int color, 
			    int back_color,
			    int *status,
			    struct MESSAGES messages[],
			    int message_count )
{
	int i;


		for( i = 0; i <= message_count; i++ )
		{
			switch (messages[i].object_ID ) 
			{
				case TEXT_1:	
					GP142_printfXY (messages[ i ].color, messages[ i ].obj_x, 
										   messages[ i ].obj_y, 14,
										   "BE MINE");
					break;
				case TEXT_2:
					GP142_printfXY (messages[ i ].color, messages[ i ].obj_x, 
										   messages[ i ].obj_y, 14,
										   "I'M YOURS");
					break;
				case TEXT_3:
						GP142_printfXY (messages[ i ].color, messages[ i ].obj_x, 
										   messages[ i ].obj_y, 14,
										   "KISS ME");
					break;
				case TEXT_4:
						GP142_printfXY (messages[ i ].color, messages[ i ].obj_x, 
										   messages[ i ].obj_y, 14,
										   "HUG ME");
					break;
				case TEXT_5:
						GP142_printfXY (messages[ i ].color, messages[ i ].obj_x, 
										   messages[ i ].obj_y, 14,
										   "IF YOU LOVED ME YOU WOULD ");
					break;
				default:
					/* Unknown shape selected */
					break;

			} /*end switch*/
		}
	
}

/*
 * Draw a heart on the card. A heart will be made by two overlapping
 * circles and a triangle.
 *
 * The pulsation is caused by adding a small, random amount to the 
 * heart height each time this function is called.
 */
void DrawHeart (int x, int y, int color, int h) {

	GP142_circleXY (color, x - h + (h/5), y, h);
	GP142_circleXY (color, x + h - (h/5), y, h);
	GP142_triangleXY (color, x - h*2 +(h/5), y-(h/3),
						     x + h*2 -(h/5), y-(h/3),
						     x,				 y - h*2 -(h/3), 
							 FILL);
}


/*
 * Draw a star on the card.
 *
 * We make the star twinkle by selecting the number of points randomly.  Each 
 * time it is redrawn, it is slightly different than the time before, which 
 * makes it appear to pulsate,
 */
#define STARPOINTS 60
#define STARRADIUS 40
#define PI 3.1416
void DrawStar (int x, int y, int color) {

	int sp;
	double angle;
	int x1, y1;

	sp = STARPOINTS + (rand () %3);
	for (angle = 0.0; angle < 2 * PI; angle += (2*PI)/sp) {
		x1 = (int) (cos (angle) * STARRADIUS);
		y1 = (int) (sin (angle) * STARRADIUS);
		GP142_lineXY (color, x+x1, y+y1, x-x1, y-y1, 1);

	}
}


/*
 * Mouse clicks occur in one of three regions of interest: on buttons, 
 * on the card, or anywhere else.
 */
int  ClassifyMouseClick(int mouse_x, int mouse_y)
{
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
    return CLICK_BUTTON;
  else if (mouse_x >= PAGE_LLX && mouse_x < PAGE_LLX + PAGE_WIDTH
	  && mouse_y >= PAGE_LLY && mouse_y < PAGE_LLY + PAGE_HEIGHT)
    return CLICK_CARD;
  else
    return CLICK_OUTSIDE;

}


/*
 * Decide where a mouse click occured, and react appropriately.
 */
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
					  int *status, int *message_count, int *shape_count,
					  int *object_type, 
					  int *object_num, int *object_color, 
					  int *object_x, int *object_y, int *weather_type,
					  struct MESSAGES messages[], struct SHAPES shapes[],
					  int *shape_color, int *text_color )
{
	static int not_first_time  = FALSE;
	static int not_first_timeB = FALSE;
	int mouse_click;
	mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
			
	if (mouse_click == CLICK_BUTTON) 
	{		
		/* A button has been clicked.  Call a function to handle it*/
		/* most of the variables passed as args will NOT change*/
		HandleButton(mouse_x, mouse_y, background_color, status, 
					 message_count, shape_count, object_type, 
					 object_num, weather_type, messages, 
					 shapes, &not_first_time, &not_first_timeB,
					 shape_color, text_color);
	} 
	if (mouse_click == CLICK_CARD ) 
	{
		/*store current shape coordinates before adding a new one */

		if( *object_type == OBJECT_SHAPE )
		{
			shapes[ *shape_count ].obj_x = mouse_x;
			shapes[ *shape_count ].obj_y = mouse_y;	
		}
		else if( *object_type == OBJECT_MESSAGE )
		{
			messages[ *message_count ].obj_x = mouse_x;
			messages[ *message_count ].obj_y = mouse_y;	
		}
		/* Add a shape */
		AddShape(mouse_x, mouse_y, status, message_count, shape_count, 
			     object_type, object_num, object_color, 
			     object_x, object_y);
		if( *object_type == OBJECT_SHAPE )
			not_first_time  = TRUE;
		else if( *object_type == OBJECT_MESSAGE )
			not_first_timeB = TRUE;
	}


	/* Ignore any other mouse clicks */
}

/* 
 * Figure out which button was clicked, if any, and do the right 
 * thing.
 */
#define WEATHER_CHOICES	5
#define SPEED_CHANGE	100
void HandleButton(int x, int y, int *background_color, int *status,
				  int *message_count, int *shape_count, 
				  int *object_type, int *object_num,
				  int *weather_type, struct MESSAGES messages[],
				  struct SHAPES shapes[],
				  int *not_first_time,
				  int *not_first_timeB,
				  int *shape_color,
				  int *text_color)
{
	int buttonNum = 0;
	
	/* If we're outside of this area, we could not have clicked on
	* a button.
	*/
	if (x > -GP142_XMAX + BUTTON_WIDTH)  
		return ;	/*That's an error situation*/
	
					/* We know the mouse clicked in the column of buttons. Calculate
					* which one.
	*/
	buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;	 
	
	switch(buttonNum) 
	{
		case 0:
			/* Change the background color */
			*background_color = (*background_color + 1) % MAX_COLORS;
			break;
		case 1:
			/* Change the type of the currently selected object */
			
			if( *not_first_time == TRUE )
			{
				*shape_count += 1;		
			}
		
			*not_first_time = FALSE;
			*object_type = OBJECT_SHAPE;
			*object_num = (*object_num + 1) % MAX_SHAPES;
			shapes[ *shape_count ].object_ID = *object_num;
			break;
		case 2:
			{
				*weather_type = (*weather_type+1) % WEATHER_CHOICES;
				*status = STATUS_WEATHER;
			}
			break;
		case 3:
			if( *not_first_timeB == TRUE )
			{
				*message_count += 1;		
			}
		
			*not_first_timeB = FALSE;
			*object_type = OBJECT_MESSAGE;
			*object_num = ((( *object_num + 1 ) % MAXI_MESSAGES)+5);
			messages[ *message_count ].object_ID = *object_num;
				
			break;
		case 4:
			{
				(*shape_color = (*shape_color +1 % MAX_COLORS));
				shapes[ *shape_count ].color = *shape_color;
			}
			break;
		case 5:
			{
				(*text_color = (*text_color +1 % MAX_COLORS));
				messages[ *message_count ].color = *text_color;
			}
			break;
		case 6:
			{
			}
			break;
		default:
			*status = 999;
			/*Bad news if this is ever reached! */
			break;
	}
}


/* If there's room for another shape, add it to the card. */
void AddShape(int x, int y, int *status, int *message_count,
			  int *shape_count, int *object_type, int *object_num, 
			  int *object_color, int *object_x, int *object_y)
{
	if (*shape_count <= 10) 
	{
		*status = STATUS_SELECTED;
		if( *object_type == OBJECT_SHAPE )
			*object_num = SHAPE_HEART;
		else
			*object_num = TEXT_1;
		*object_color = RED;
		*object_x = x;
		*object_y = y;
	}

}

/****************************************************************/
/* This function calls Draw_Road and passes a starting point    */
/* depending on which iteration it's in (causing the appearance */
/* of movement)													*/

#define LINEWIDTH  4
#define ROADWIDTH  60
#define NUM_OF_LINES 6	/* change this to lengthen the road		*/
#define PI 3.1416
void Road( int color, int back_color )
{
	
	static int t = 1; /* counts calls */
	int callcount = t;
	
	int x, x0 = 10;
	int y, y0 = 140;

	/* to make the flow smoother change the mod# AND add		*/
	/* an if statement to account for it						*/
	if( (t % 4) == 0 )
	{
		x = x0 - 15;
		y = y0 - 30;

		Draw_Road( back_color, x, y, back_color );
		
		x = x0;
		y = y0;
		
		Draw_Road( color, x, y, back_color );
		Draw_Tree( callcount, x, y );
		t++;
		
	}

	else if( (t % 4) == 1 )
	{
		x = x0;
		y = y0;
		
		Draw_Road( back_color, x, y, back_color );
		
		x = x0 - 5;
		y = y0 - 10;
		
		Draw_Road( color, x, y, back_color );
		Draw_Tree( callcount, x, y );
		t++;
	}

	else if( (t % 4) == 2 )
	{
		x = x0 - 5;
		y = y0 - 10;
		
		Draw_Road( back_color, x, y, back_color );
		
		x = x0 - 10;
		y = y0 - 20;
		
		Draw_Road( color, x, y, back_color );
		Draw_Tree( callcount, x, y );
		t++;
		
	}

	else if( (t % 4) == 3 )
	{
		x = x0 - 10;
		y = y0 - 20;
		
		Draw_Road( back_color, x, y, back_color );
		
		x = x0 - 15;
		y = y0 - 30;
		
		Draw_Road( color, x, y, back_color );
		Draw_Tree( callcount, x, y );
		t++;
		
	}
	Draw_Car( RED, back_color);
}

/****************************************************************/
/* This function draws the road lines on both sides				*/

void Draw_Road( int color, 
			    int x, 
				int y,
				int back_color )
{
	int LineLength = 6;
	int distance;
	int x1, y1, tempx, tempy;
	static int callcount = 0;
	
	tempx = x;
	tempy = y;

	for (distance = 1; distance <= NUM_OF_LINES; distance++ ) 
	{
		x1 = (int) (cos (PI/3) * (LineLength + (2 * distance)));
		y1 = (int) (sin (PI/3) * (LineLength + (2 * distance)));
		GP142_lineXY (color, x+x1, y+y1, x-x1, y-y1, 3);
		x -= 15 + (3 * distance );
		y -= 30 + (6 * distance );
		
	}
	
	
	x = -tempx + 65;
	y = tempy;

	

	for (distance = 1; distance <= NUM_OF_LINES; distance++ ) 
	{
		x1 = (int) (cos (2*PI/3) * (LineLength + (2 * distance)));
		y1 = (int) (sin (2*PI/3) * (LineLength + (2 * distance)));
		GP142_lineXY (color, x+x1, y+y1, x-x1, y-y1, 3);
		x += 15 + (3 * distance );
		y -= 30 + (6 * distance );
		GP142_rectangleXY ( back_color, -138,  150, 200,  117, FILL);
		GP142_rectangleXY ( back_color, -138, -117, 200, -147, FILL);
	}
		
}
/****************************************************************/
/* This function calls functions to draw the whole car			*/

void Draw_Car( int color,
			   int back_color )
{
	Draw_Dash( back_color + 4 );
	Draw_Hood( back_color + 4 );
	Draw_Steering( color, back_color );
}
/****************************************************************/
/* This function draws the dash									*/

#define DASH_CENTER_X	 34	
#define DASH_CENTER_Y	-80
#define DASH_HEIGHT		 15
#define DASH_WIDTH		 90

void Draw_Dash( int color )
{
	int x = DASH_CENTER_X;
	int y = DASH_CENTER_Y;
	int x1 = DASH_WIDTH;
	int y1 = DASH_HEIGHT;

	GP142_lineXY ( color, x-x1, y+y1, x+x1, y+y1, 2);
	GP142_lineXY ( color, x+x1, y+y1, x+x1+(DASH_HEIGHT/2), y+y1-(DASH_HEIGHT), 2);
	GP142_lineXY ( color, x-x1, y+y1, x-x1-(DASH_HEIGHT/2), y+y1-(DASH_HEIGHT), 2);
}
/****************************************************************/
/* This function draws the hood									*/

#define HOODLENGTH		60
void Draw_Hood( int color )
{
	int x1 = DASH_WIDTH;
	int y1 = DASH_HEIGHT;
	int x = DASH_CENTER_X;
	int y = DASH_CENTER_Y;
	

	GP142_triangleXY ( color, x - x1+10, y + y1, 
		                      x - x1+25, y + y1,
							  x - x1+50, y + y1+HOODLENGTH,
					   2 );
	GP142_triangleXY ( color, x + x1-10, y + y1, 
		                      x + x1-25, y + y1,
							  x + x1-50, y + y1+HOODLENGTH,
					   2 );
	GP142_lineXY ( color, x + x1-50, y + y1+HOODLENGTH,
			              x - x1+50, y + y1+HOODLENGTH,
					   2 );
}

/****************************************************************/
/* This function draws the steering wheel						*/

void Draw_Steering( int color,
				    int back_color)
{
	
	int r = 30;
	const int x = 10;
	const int y = -80;
	int x1;
	int y1;
	static double angle = 0;
	int h = (HEART_WIDTH/8) + (rand () %2);

	/*draw the cross in middle of steering wheel */
	x1 = (int) (cos (angle) * r)-1;
	y1 = (int) (sin (angle) * r)-1;
	GP142_lineXY (color, x+x1, y+y1, x-x1, y-y1, 2);
	angle += (PI/2);
	x1 = (int) (cos (angle) * r)-1;
	y1 = (int) (sin (angle) * r)-1;
	GP142_lineXY (color, x+x1, y-y1, x-x1, y+y1, 2);
	angle += (3*PI/2);
	
	/* the oval is to cut off any bits of the cross that may extend
	/* beyond the steering wheel.  This is a problem because when
	/* determining cross line length the length is converted to an int
	/* when it needs to be a double for odd angles */
	GP142_ovalXY(back_color, x+(r), y+(r), x-(r), y-(r), 8);
	DrawHeart( x, y, back_color + 5, h);
	GP142_ovalXY(color, x+(r-5), y+(r-5), x-(r-5), y-(r-5), 5);


		
}
/***********************************************************************************/
void Draw_Weather( int weather,
				   int x,
				   int y,
				   int back_color )
{
	switch( weather )
	{
		case CALM  : break;
		case SUNNY : Draw_Sunny_Day();
					 break;
		case RAINY : Draw_Rainy_Day(back_color);
					 break;
		/*case SNOWY : Draw_Snow();
					 break;
		case WEIRD : Draw_UFO();
					 break;*/
	}
}

/***********************************************************************************/
#define SUN_RADIUS		40
#define BLINK_DELAY		15
#define EYE_RADIUS		 8
#define NUM_LASHES		 7.0
#define NUM_RAYS		 6.0
#define SQUIG_RADIUS	 5.0
#define NUM_SQUIGS		 3
#define RAY_LENGTH		 6
#define MAX_RAY_LINES	 3

void Draw_Sunny_Day()
{
	int x, y, x1, y1, eye1x, eye2x, eyesy, smilex, smiley, rayx, rayy;
	int j = 1;
	double ray_angle;
	int lines;
	double angle;
	static int callcount = 0;


	x = PAGE_LLX + SUN_RADIUS + 25; 	
	y = PAGE_LLY + PAGE_HEIGHT - SUN_RADIUS - 25;
	eye1x  = x + SUN_RADIUS/2;
	eye2x  = x - SUN_RADIUS/2;
	eyesy  = y + SUN_RADIUS/2 -9;
	smilex = PAGE_LLX + SUN_RADIUS;
	smiley = PAGE_LLY + PAGE_HEIGHT - SUN_RADIUS/2;
	
	GP142_circleXY( YELLOW, x, y, SUN_RADIUS);

	/* draw mouth */
	GP142_ovalXY( BLACK, x-SUN_RADIUS*3/5, y+(SUN_RADIUS/6), 
		                 x+SUN_RADIUS*3/5, y-(SUN_RADIUS*2/3), 3);
	GP142_rectangleXY( YELLOW, x-(SUN_RADIUS*3/5+3), y+(SUN_RADIUS/6+3), 
		                       x+(SUN_RADIUS*3/5+3), y-(SUN_RADIUS/4+3), FILL);

	/* draw squiggly rays */	
	for(angle = 0; angle < (2*PI); angle += (PI/NUM_RAYS) )
	{
		rayx = x + (int)(cos (angle) * ((SUN_RADIUS)+3));
		rayy = y + (int)(sin (angle) * ((SUN_RADIUS)+3));

		for( lines = 0; lines <= MAX_RAY_LINES; lines++)
		{
			/*allow two lines to be drawn from the endpoint of each 
			/*	previous line										*/
			ray_angle = angle + (1/((rand()%2)+1)); 
			x1 = (int) (cos (ray_angle) *  RAY_LENGTH);
			y1 = (int) (sin (ray_angle) *  RAY_LENGTH);		
			GP142_lineXY (YELLOW, rayx, rayy, 
								  rayx + x1, rayy + y1, 1);
			rayx += x1;
			rayy += y1;
		}
		
	}
	/* Draw blinking eyes */
	if( (callcount % BLINK_DELAY) >= 2)
	{
		/* draw lashes on open eyes */
		for( angle = 0; angle <= PI; angle += (PI / NUM_LASHES) )
		{
			x1 = (int) (cos (angle) * (EYE_RADIUS + 8));
			y1 = (int) (sin (angle) * (EYE_RADIUS + 8));
			GP142_lineXY (BLACK, eye1x,    eyesy, 
							     eye1x+x1, eyesy+y1, 1);
			GP142_lineXY (BLACK, eye2x,    eyesy, 
							     eye2x+x1, eyesy+y1, 1);
		}
		/* draw open eyes */
		GP142_circleXY (BLACK, eye1x, eyesy, EYE_RADIUS);
		GP142_circleXY (BLACK, eye2x, eyesy, EYE_RADIUS);
		callcount++;
	}
	/* draw closed eyes... */
	else 
	{
		GP142_lineXY (BLACK, eye1x+(EYE_RADIUS), eyesy, 
			                 eye1x-(EYE_RADIUS), eyesy, 2);
		GP142_lineXY (BLACK, eye2x+(EYE_RADIUS), eyesy, 
			                 eye2x-(EYE_RADIUS), eyesy, 2);
		callcount++;
	}
}
/***********************************************************************************/
#define TREE_HEIGHT		 7
#define TREE_WIDTH		 2
#define HOLE_WIDTH		15
#define HOLE_HEIGHT		25
#define TREE_RADIUS		 1.6
#define TREE_JUMP		 2
#define RATE			20
#define TREE_DISTANCE	20

void Draw_Tree( int callcount, int x, int y )
{
	static int x1, x2;
	static int y1, y2; 
	int treeX, treeY, treeR;

	if( (callcount%40) == 1 )
	{
		x1 = x + 70;
		y1 = y;
	}
	
	/* the 40 controls how often the tree appears,
	/* the 20 controls how far it goes before starting over */
	if( (callcount%40) <= TREE_DISTANCE)
	{
		/* TREE_JUMP controls the tree speed (how far 
		/* it travels with each loop						*/
		x1 += (int)((callcount%RATE)/TREE_JUMP * 1.1); 
		y1 -= (int)((callcount%RATE)/TREE_JUMP * 2);
		
		treeX = (callcount%RATE) * TREE_WIDTH; 
		treeY = (callcount%RATE) * TREE_HEIGHT;
		treeR = (int)((callcount%RATE) * TREE_RADIUS);

		/* tree trunk */
		GP142_rectangleXY( BROWN, x1, 
								  y1, 
								  x1 + treeX, 
								  y1 + treeY, 
								  FILL);
		/* a hole in the tree, like a woodpecker nest */
		GP142_ovalXY( BLACK, x1+(treeX/3), 
							 y1+(treeY*1/3), 
							 x1+(treeX/3) + (treeX/3), 
							 y1+(treeY*1/3) + (treeX/2), 
							 FILL);
		/* draw three green circles for branches */
		x2 = x1 + (int)(treeX*1.2); 
		y2 = y1 + treeY;
		GP142_circleXY( GREEN, x2, y2, treeR);
		x2 = x1 - (int)(treeX*.2); 
		y2 = y1 + treeY;
		GP142_circleXY( GREEN, x2, y2, treeR);
		x2 = x1 + (treeX/2); 
		y2 = y1 + (int)(treeY*1.3);
		GP142_circleXY( GREEN, x2, y2, treeR);

		GP142_rectangleXY( WHITE, PAGE_LLX + PAGE_WIDTH + 1, 
								  PAGE_LLY + 100, 
								  PAGE_LLX + PAGE_WIDTH + 70, 
								  PAGE_LLY + 400, 
								  FILL); 
	}
		
}
/***********************************************************************************/
#define MAX_LINES	4
void Draw_Rainy_Day( int back_color)
{
	int i;							/*generic 'for' index							*/
	static int callcount = 0;		/*keeps track of calls to this function			*/
	int size;						/*drop size										*/
	int space;						/*horizontal space btwn drops					*/
	int ground;						/*how far down the drops fall					*/
	int pageheight;					/*determines current row for rain drops			*/
	int lgtnngx, lgtnngy;			/*starting point								*/
	int lgtnng_angle, x1, y1, lines;/*length and direction of bolt pieces			*/
	static int strtptX, strtptY;    /*keeps track of the bolt's starting point		*/

	ground = 150 + (rand()%40 );

	/* draw rain */
	for( pageheight = PAGE_HEIGHT; pageheight >= ground; pageheight -= 8)
	{
		for( i = 0; i <= 23; i++)
		{
			size = (rand()%3);
			space = (rand()%6+1);
			GP142_circleXY( BLUE, (PAGE_LLX + 5) + (15 * i) + space,
								   PAGE_LLY + pageheight - (callcount%3*6), 
								   size);
		}
	}
	callcount++;

	/* draw lightning */
	if( (callcount%30) == 0 )
		{
			/*refresh every 30 frames for new start point*/ 
			lgtnngx = strtptX = PAGE_LLX + (rand()%250 + 100);
			lgtnngy = strtptY = PAGE_LLY + PAGE_HEIGHT - (rand()%50 + 25);
		}
	/*increase the 2 to cause bolt to 'linger' longer */
	if( (callcount%30) <= 2 )
	{
		/*strtpt_ will hold bolt starting point for 3 iterations	 
		/*	while lgtnng_ is changed								*/ 
		lgtnngx = strtptX;
		lgtnngy = strtptY;

		for( lines = 0; lines <= MAX_LINES; lines++)
		{
			/*allow two lines to be drawn from the endpoint of each 
			/*	previous line										*/
			lgtnng_angle = (int)(PI + (rand()%3)); 
			x1 = (int) (cos (lgtnng_angle) *  30);
			y1 = (int) (sin (lgtnng_angle) *  30);		
			GP142_lineXY (YELLOW, lgtnngx, lgtnngy, 
								  lgtnngx + x1, lgtnngy + y1, 2);
			x1 = (int) (sin (lgtnng_angle) *  30);
			y1 = (int) (cos (lgtnng_angle) *  30);		
			GP142_lineXY (YELLOW, lgtnngx, lgtnngy, 
								  lgtnngx + x1, lgtnngy + y1, 2);
			lgtnngx += x1;
			lgtnngy += y1;
		}
	}

}

